// stealgsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "stealgs.h"
#include "stealgsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStealgsDlg dialog

CStealgsDlg::CStealgsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStealgsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStealgsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CStealgsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStealgsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CStealgsDlg, CDialog)
	//{{AFX_MSG_MAP(CStealgsDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStealgsDlg message handlers

UINT shark2rts(char* szGscode) {
	ASSERT(strlen(szGscode) == 8);
	char szTemp1[3], szTemp2[3];
	int iTemp1, iTemp2;
	
	strncpy(szTemp1, szGscode + 4, 2); // lower bits
	szTemp1[2] = '\0';
	strncpy(szTemp2, szGscode + 6, 2); // higher bits
	szTemp2[2] = '\0';
	sscanf(szTemp1, "%x", &iTemp1);
	sscanf(szTemp2, "%x", &iTemp2);
	return iTemp2 * 0x100 + iTemp1 + 0x24c;
}


BOOL CStealgsDlg::OnInitDialog()
{
	const UINT PD_ID_FILE_OPEN = 0x9c46;
	const UINT PD_ID_STATE_LOAD_SLOT5 = 0x9c5e;
	const UINT PD_ID_STATE_SAVE_SLOT5 = 0x9c60;
	const UINT PD_GS_SNAPSHOT_SIZE = 115277;

	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CStatic* staticTextout = (CStatic*) GetDlgItem(IDC_TEXTOUT);
	BOOL fItWorked = FALSE;
	CWnd* wndPd;

	CString szBuff;
	wndPd = CWnd::FindWindow(NULL, "Prototype-D");
	
	if (wndPd == NULL) {
		szBuff += "No instance of Prototype-D found running.";
	}
	else
	{
		szBuff += "Prototype-D instance found.\n";
		CFileDialog dlgGbc(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "GB Image (*.GB,*.GBC)|*.gb; *.gbc||");
		dlgGbc.DoModal();
		CString szGbcfilename;
		szGbcfilename = dlgGbc.GetPathName();
		if (szGbcfilename.IsEmpty())
			szBuff += "No ROM data file selected. Steal aborted.";
		else {
			szBuff += "ROM data file '";
			szBuff += szGbcfilename;
			szBuff += "' selected.\n";
			CString szRt4filename;
			szRt4filename = szGbcfilename;
			int iDotPos = -1, iNextDotPos;
			iNextDotPos = szRt4filename.Find(".", iDotPos + 1);
			while (iNextDotPos != -1) {
				iDotPos = iNextDotPos;
				iNextDotPos = szRt4filename.Find(".", iDotPos + 1);
			}
			szRt4filename = szRt4filename.Left(iDotPos) + ".rt4";
			CFileStatus statusOld, statusNew;
			BOOL fExisting, fUpdated;
			char szBackup[PD_GS_SNAPSHOT_SIZE];
			char szSnapshot[PD_GS_SNAPSHOT_SIZE];
			CTime mtime_old;

			fExisting = CFile::GetStatus( szRt4filename, statusOld );
			if (fExisting) {
				szBuff += "Existing '";
				szBuff += szRt4filename;
				szBuff += "' found.\n";
                CFile fileRt4;
				CFileException e;
				if (!fileRt4.Open(szRt4filename, CFile::modeRead, &e)) {
					szBuff += "Error encountered opening '";
					szBuff += szRt4filename;
					szBuff += "'.\n";
					fExisting = FALSE;
				}
				else {
					try {
						fileRt4.Read(szBackup, PD_GS_SNAPSHOT_SIZE);
						fileRt4.Close();
						szBuff += "Snapshot '";
						szBuff += szRt4filename;
						szBuff += "' backed up.\n";
					}
					catch (CFileException e) {
						szBuff += "Error encountered reading '";
						szBuff += szRt4filename;
						szBuff += "'.\n";
						fExisting = FALSE;
					}
				}
				mtime_old = statusOld.m_mtime;
			}
			wndPd->SendMessage(WM_COMMAND, PD_ID_STATE_SAVE_SLOT5);
			szBuff += "Snapshot saved to slot 5.\n";
			fUpdated = CFile::GetStatus( szRt4filename, statusNew );
			if (!fUpdated || (fExisting && statusNew.m_mtime == mtime_old)) {
				szBuff += "File '";
				szBuff += szRt4filename;
				szBuff += "' did not correspond to snapshot 5. ";
				szBuff += "Perhaps you specified the wrong ROM data file?\n";
			}
			else {
                CFile fileRt4;
				CFileException e;
				if (!fileRt4.Open(szRt4filename, CFile::modeReadWrite, &e)) {
					szBuff += "Error encountered when opening snapshot 5.\n";
				}
				else {
					try {
						fileRt4.Read(szSnapshot, PD_GS_SNAPSHOT_SIZE);
						ASSERT(shark2rts("01??16D1") == 0xd362);
						if (szSnapshot[shark2rts("01??16D1")] != 0x02) {
							szBuff += "The snapshot says you aren't in a trainer battle. ";
							szBuff += "Perhaps you really aren't battling a trainer currently, or you just ran this program twice, or you aren't even running the U.S. version of Pokemon Gold/Silver in the emulator?\n";
						}
						else {
							UINT iWildSkillLocation, iTameSkillLocation;

							szSnapshot[shark2rts("01??16D1")] = 0x01;
							//iWildSkillLocation = shark2rts("01??F1D0");
							iWildSkillLocation = 0x4c1d;
							iTameSkillLocation = 0xd259 + 0x30 * szSnapshot[shark2rts("01??41CB")];
							//char foobar[30];
							//sprintf(foobar, "%x %x %x %x\n", szSnapshot[iTameSkillLocation+0],
							//	szSnapshot[iTameSkillLocation+1],szSnapshot[iTameSkillLocation+2], szSnapshot[iTameSkillLocation+3]);
							//szBuff += foobar;x
							szSnapshot[iWildSkillLocation +  0] = szSnapshot[iTameSkillLocation +  0];
							szSnapshot[iWildSkillLocation +  1] = szSnapshot[iTameSkillLocation +  1];
							szSnapshot[iWildSkillLocation +  2] = szSnapshot[iTameSkillLocation +  2];
							szSnapshot[iWildSkillLocation +  3] = szSnapshot[iTameSkillLocation +  3];
							szSnapshot[                 0x4c21] = szSnapshot[iTameSkillLocation + 21];
							szSnapshot[                 0x4c22] = szSnapshot[iTameSkillLocation + 22];
							szSnapshot[                 0x4c23] = szSnapshot[iTameSkillLocation + 23];
							szSnapshot[                 0x4c24] = szSnapshot[iTameSkillLocation + 24];
							fileRt4.SeekToBegin();
							fileRt4.Write(szSnapshot, PD_GS_SNAPSHOT_SIZE);
							fItWorked = TRUE;
						}

						
						fileRt4.Close();

						if (fItWorked) {
							szBuff += "Snapshot in slot 5 altered appropriately.\n";
							wndPd->SendMessage(WM_COMMAND, PD_ID_STATE_LOAD_SLOT5);
							szBuff += "Snapshot in slot 5 reloaded.\n";
						}
					}
					catch (CFileException e) {
						szBuff += "Error encountered while editing snapshot 5.\n";
						fItWorked = FALSE;
					}
				}

				if (fExisting) {
					CFile fileRt4;
					CFileException e;
					if (!fileRt4.Open(szRt4filename, CFile::modeWrite, &e)) {
						szBuff += "Error encountered restoring '";
						szBuff += szRt4filename;
						szBuff += "'.\n";
					}
					else {
						try {
							fileRt4.Write(szBackup, PD_GS_SNAPSHOT_SIZE);
							fileRt4.Close();
							szBuff += "Backup for '";
							szBuff += szRt4filename;
							szBuff += "' restored.\n";
						}
						catch (CFileException e) {
							szBuff += "Error encountered restoring '";
							szBuff += szRt4filename;
							szBuff += "'.\n";
							fExisting = FALSE;
						}
					}
				}
			}

		}
	}

	if (fItWorked)
		szBuff += "\nYou are ready to throw a poke ball and steal that pokemon!\n";
	staticTextout->SetWindowText(szBuff);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CStealgsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CStealgsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
